<template>
    <i-form :model="this.data" class='app-form' ref='form'  id='form' style="">
    <input style="display:none;" />
    <row >
            
<i-col v-show="detailsModel.grouppanel2.visible" :style="{}"  :lg="{ span: 24, offset: 0 }">
    <app-form-group layoutType="TABLE_24COL" titleStyle="" class='' uiActionGroup="detailsModel.grouppanel2.uiActionGroup" @groupuiactionclick="groupUIActionClick($event)" :caption="$t('entities.emserviceevl.main4_form.details.grouppanel2')" :isShowCaption="false" uiStyle="DEFAULT" :titleBarCloseMode="0" :isInfoGroupMode="false" >    
    <row>
        <i-col v-show="detailsModel.servicename.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='servicename' :itemRules="this.rules.servicename" class='' :caption="$t('entities.emserviceevl.main4_form.details.servicename')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.servicename.error" :isEmptyCaption="false" labelPos="LEFT">
    <app-picker 
  :formState="formState"
  :data="data"
  :context="context"
  :viewparams="viewparams"
  :itemParam='{ }' 
  :disabled="detailsModel.servicename.disabled"
  name='servicename'
  deMajorField='emservicename'
  deKeyField='emservice'
  :service="service"
  :acParams="{ serviceName: 'EMServiceService', interfaceName: 'FetchDefault'}"
  valueitem='serviceid' 
  :value="data.servicename" 
  editortype="" 
  :pickupView="{ viewname: 'emservicepickup-view', title: $t('entities.emservice.views.pickupview.title'), deResParameters: [], parameters: [{ pathName: 'emservices', parameterName: 'emservice' }, { pathName: 'pickupview', parameterName: 'pickupview' } ], placement:'' }"
  style=""  
  @formitemvaluechange="onFormItemValueChange">
</app-picker>

</app-form-item>

</i-col>
<i-col v-show="detailsModel.empname.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='empname' :itemRules="this.rules.empname" class='' :caption="$t('entities.emserviceevl.main4_form.details.empname')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.empname.error" :isEmptyCaption="false" labelPos="LEFT">
    <app-picker 
  :formState="formState"
  :data="data"
  :context="context"
  :viewparams="viewparams"
  :itemParam='{ }' 
  :disabled="detailsModel.empname.disabled"
  name='empname'
  deMajorField='pfempname'
  deKeyField='pfemp'
  :service="service"
  :acParams="{ serviceName: 'PFEmpService', interfaceName: 'FetchDefault'}"
  valueitem='empid' 
  :value="data.empname" 
  editortype="" 
  :pickupView="{ viewname: 'pfemppickup-view', title: $t('entities.pfemp.views.pickupview.title'), deResParameters: [], parameters: [{ pathName: 'pfemps', parameterName: 'pfemp' }, { pathName: 'pickupview', parameterName: 'pickupview' } ], placement:'' }"
  style=""  
  @formitemvaluechange="onFormItemValueChange">
</app-picker>

</app-form-item>

</i-col>
<i-col v-show="detailsModel.evlregion.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='evlregion' :itemRules="this.rules.evlregion" class='' :caption="$t('entities.emserviceevl.main4_form.details.evlregion')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.evlregion.error" :isEmptyCaption="false" labelPos="LEFT">
     <dropdown-list v-model="data.evlregion" :data="data" :itemParam="{}" :disabled="detailsModel.evlregion.disabled"  tag='EMSERVICEEVLREGION' codelistType='STATIC' placeholder='请选择...' style=""></dropdown-list>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.evldate.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='evldate' :itemRules="this.rules.evldate" class='' :caption="$t('entities.emserviceevl.main4_form.details.evldate')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.evldate.error" :isEmptyCaption="false" labelPos="LEFT">
    <date-picker type="date" :transfer="true" format="yyyy-MM-dd" placeholder="请选择时间..." :value="data.evldate" :disabled="detailsModel.evldate.disabled" style="min-width: 150px; width:100px;" @on-change="(val1, val2) => { this.data.evldate = val1 }"></date-picker>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.evlresult3.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='evlresult3' :itemRules="this.rules.evlresult3" class='' :caption="$t('entities.emserviceevl.main4_form.details.evlresult3')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.evlresult3.error" :isEmptyCaption="false" labelPos="LEFT">
    <input-box v-model="data.evlresult3"  @enter="onEnter($event)"   unit=""  :disabled="detailsModel.evlresult3.disabled" type='number'  style=""></input-box>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.evlresult7.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='evlresult7' :itemRules="this.rules.evlresult7" class='' :caption="$t('entities.emserviceevl.main4_form.details.evlresult7')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.evlresult7.error" :isEmptyCaption="false" labelPos="LEFT">
    <input-box v-model="data.evlresult7"  @enter="onEnter($event)"   unit=""  :disabled="detailsModel.evlresult7.disabled" type='number'  style=""></input-box>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.evlresult2.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='evlresult2' :itemRules="this.rules.evlresult2" class='' :caption="$t('entities.emserviceevl.main4_form.details.evlresult2')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.evlresult2.error" :isEmptyCaption="false" labelPos="LEFT">
    <input-box v-model="data.evlresult2"  @enter="onEnter($event)"   unit=""  :disabled="detailsModel.evlresult2.disabled" type='number'  style=""></input-box>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.evlresult8.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='evlresult8' :itemRules="this.rules.evlresult8" class='' :caption="$t('entities.emserviceevl.main4_form.details.evlresult8')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.evlresult8.error" :isEmptyCaption="false" labelPos="LEFT">
    <input-box v-model="data.evlresult8"  @enter="onEnter($event)"   unit=""  :disabled="detailsModel.evlresult8.disabled" type='number'  style=""></input-box>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.evlresult5.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='evlresult5' :itemRules="this.rules.evlresult5" class='' :caption="$t('entities.emserviceevl.main4_form.details.evlresult5')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.evlresult5.error" :isEmptyCaption="false" labelPos="LEFT">
    <input-box v-model="data.evlresult5"  @enter="onEnter($event)"   unit=""  :disabled="detailsModel.evlresult5.disabled" type='number'  style=""></input-box>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.evlresult6.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='evlresult6' :itemRules="this.rules.evlresult6" class='' :caption="$t('entities.emserviceevl.main4_form.details.evlresult6')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.evlresult6.error" :isEmptyCaption="false" labelPos="LEFT">
    <input-box v-model="data.evlresult6"  @enter="onEnter($event)"   unit=""  :disabled="detailsModel.evlresult6.disabled" type='number'  style=""></input-box>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.evlresult9.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='evlresult9' :itemRules="this.rules.evlresult9" class='' :caption="$t('entities.emserviceevl.main4_form.details.evlresult9')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.evlresult9.error" :isEmptyCaption="false" labelPos="LEFT">
    <input-box v-model="data.evlresult9"  @enter="onEnter($event)"   unit=""  :disabled="detailsModel.evlresult9.disabled" type='number'  style=""></input-box>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.evlresult4.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='evlresult4' :itemRules="this.rules.evlresult4" class='' :caption="$t('entities.emserviceevl.main4_form.details.evlresult4')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.evlresult4.error" :isEmptyCaption="false" labelPos="LEFT">
    <input-box v-model="data.evlresult4"  @enter="onEnter($event)"   unit=""  :disabled="detailsModel.evlresult4.disabled" type='number'  style=""></input-box>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.evlresult1.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='evlresult1' :itemRules="this.rules.evlresult1" class='' :caption="$t('entities.emserviceevl.main4_form.details.evlresult1')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.evlresult1.error" :isEmptyCaption="false" labelPos="LEFT">
    <input-box v-model="data.evlresult1"  @enter="onEnter($event)"   unit=""  :disabled="detailsModel.evlresult1.disabled" type='number'  style=""></input-box>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.evlresult.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='evlresult' :itemRules="this.rules.evlresult" class='' :caption="$t('entities.emserviceevl.main4_form.details.evlresult')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.evlresult.error" :isEmptyCaption="false" labelPos="LEFT">
    <app-span   name='evlresult'
:value="data.evlresult" style=""></app-span>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.serviceevlstate.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='serviceevlstate' :itemRules="this.rules.serviceevlstate" class='' :caption="$t('entities.emserviceevl.main4_form.details.serviceevlstate')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.serviceevlstate.error" :isEmptyCaption="false" labelPos="LEFT">
     <dropdown-list v-model="data.serviceevlstate" :data="data" :itemParam="{}" :disabled="detailsModel.serviceevlstate.disabled"  tag='EMSERVICEEVLSTATE' codelistType='STATIC' placeholder='请选择...' style=""></dropdown-list>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.evlmark.visible" :style="{}"  :lg="{ span: 24, offset: 0 }" :xl="{ span: 24, offset: 0 }">
    <app-form-item name='evlmark' :itemRules="this.rules.evlmark" class='' :caption="$t('entities.emserviceevl.main4_form.details.evlmark')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.evlmark.error" :isEmptyCaption="false" labelPos="LEFT">
    <input-box v-model="data.evlmark"  @enter="onEnter($event)"   unit=""  :disabled="detailsModel.evlmark.disabled" type='text'  style=""></input-box>
</app-form-item>

</i-col>
    
    </row>
</app-form-group>

</i-col>
<i-col v-show="detailsModel.grouppanel19.visible" :style="{}"  :lg="{ span: 24, offset: 0 }">
    <app-form-group layoutType="TABLE_24COL" titleStyle="" class='' uiActionGroup="detailsModel.grouppanel19.uiActionGroup" @groupuiactionclick="groupUIActionClick($event)" :caption="$t('entities.emserviceevl.main4_form.details.grouppanel19')" :isShowCaption="true" uiStyle="DEFAULT" :titleBarCloseMode="0" :isInfoGroupMode="false" >    
    <row>
        <i-col v-show="detailsModel.orgid.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='orgid' :itemRules="this.rules.orgid" class='' :caption="$t('entities.emserviceevl.main4_form.details.orgid')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.orgid.error" :isEmptyCaption="false" labelPos="LEFT">
     <dropdown-list v-model="data.orgid" :data="data" :itemParam="{}" :disabled="detailsModel.orgid.disabled"  tag='PFCL_ORG' codelistType='STATIC' placeholder='请选择...' style=""></dropdown-list>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.description.visible" :style="{}"  :lg="{ span: 24, offset: 0 }" :xl="{ span: 24, offset: 0 }">
    <app-form-item name='description' :itemRules="this.rules.description" class='' :caption="$t('entities.emserviceevl.main4_form.details.description')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.description.error" :isEmptyCaption="false" labelPos="LEFT">
    <input-box v-model="data.description"  @enter="onEnter($event)"   unit=""  :disabled="detailsModel.description.disabled" type='text'  style=""></input-box>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.createman.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='createman' :itemRules="this.rules.createman" class='' :caption="$t('entities.emserviceevl.main4_form.details.createman')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.createman.error" :isEmptyCaption="false" labelPos="LEFT">
    <app-span   name='createman'
:value="data.createman" tag='SysOperator' codelistType='DYNAMIC' style=""></app-span>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.createdate.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='createdate' :itemRules="this.rules.createdate" class='' :caption="$t('entities.emserviceevl.main4_form.details.createdate')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.createdate.error" :isEmptyCaption="false" labelPos="LEFT">
    <app-span   name='createdate'
:value="data.createdate" style=""></app-span>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.updateman.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='updateman' :itemRules="this.rules.updateman" class='' :caption="$t('entities.emserviceevl.main4_form.details.updateman')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.updateman.error" :isEmptyCaption="false" labelPos="LEFT">
    <app-span   name='updateman'
:value="data.updateman" tag='SysOperator' codelistType='DYNAMIC' style=""></app-span>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.updatedate.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='updatedate' :itemRules="this.rules.updatedate" class='' :caption="$t('entities.emserviceevl.main4_form.details.updatedate')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.updatedate.error" :isEmptyCaption="false" labelPos="LEFT">
    <app-span   name='updatedate'
:value="data.updatedate" style=""></app-span>
</app-form-item>

</i-col>
    
    </row>
</app-form-group>

</i-col>


    </row>
</i-form>
</template>

<script lang='tsx'>
import { Vue, Component, Prop, Provide, Emit, Watch, Model } from 'vue-property-decorator';
import { CreateElement } from 'vue';
import { Subject, Subscription } from 'rxjs';
import { ControlInterface } from '@/interface/control';
import { UIActionTool,Util } from '@/utils';
import EMServiceEvlService from '@/service/emservice-evl/emservice-evl-service';
import Main4Service from './main4-form-service';

import { FormButtonModel, FormPageModel, FormItemModel, FormDRUIPartModel, FormPartModel, FormGroupPanelModel, FormIFrameModel, FormRowItemModel, FormTabPageModel, FormTabPanelModel, FormUserControlModel } from '@/model/form-detail';
import { debounceTime, distinctUntilChanged } from 'rxjs/operators';


@Component({
    components: {
      
    }
})
export default class Main4Base extends Vue implements ControlInterface {

    /**
     * 名称
     *
     * @type {string}
     * @memberof Main4
     */
    @Prop() public name?: string;

    /**
     * 视图通讯对象
     *
     * @type {Subject<ViewState>}
     * @memberof Main4
     */
    @Prop() public viewState!: Subject<ViewState>;

    /**
     * 应用上下文
     *
     * @type {*}
     * @memberof Main4
     */
    @Prop() public context: any;

    /**
     * 视图参数
     *
     * @type {*}
     * @memberof Main4
     */
    @Prop() public viewparams: any;

    /**
     * 视图状态事件
     *
     * @public
     * @type {(Subscription | undefined)}
     * @memberof Main4
     */
    public viewStateEvent: Subscription | undefined;

    /**
     * 获取部件类型
     *
     * @returns {string}
     * @memberof Main4
     */
    public getControlType(): string {
        return 'FORM'
    }



    /**
     * 计数器服务对象集合
     *
     * @type {Array<*>}
     * @memberof Main4
     */    
    public counterServiceArray:Array<any> = [];

    /**
     * 建构部件服务对象
     *
     * @type {Main4Service}
     * @memberof Main4
     */
    public service: Main4Service = new Main4Service({ $store: this.$store });

    /**
     * 实体服务对象
     *
     * @type {EMServiceEvlService}
     * @memberof Main4
     */
    public appEntityService: EMServiceEvlService = new EMServiceEvlService({ $store: this.$store });
    


    /**
     * 关闭视图
     *
     * @param {any} args
     * @memberof Main4
     */
    public closeView(args: any): void {
        let _this: any = this;
        _this.$emit('closeview', [args]);
    }

    /**
     *  计数器刷新
     *
     * @memberof Main4
     */
    public counterRefresh(){
        const _this:any =this;
        if(_this.counterServiceArray && _this.counterServiceArray.length >0){
            _this.counterServiceArray.forEach((item:any) =>{
                if(item.refreshData && item.refreshData instanceof Function){
                    item.refreshData();
                }
            })
        }
    }


    
    /**
     * 获取多项数据
     *
     * @returns {any[]}
     * @memberof Main4
     */
    public getDatas(): any[] {
        return [this.data];
    }

    /**
     * 获取单项树
     *
     * @returns {*}
     * @memberof Main4
     */
    public getData(): any {
        return this.data;
    }

    /**
     * 是否默认保存
     *
     * @type {boolean}
     * @memberof Main4
     */
    @Prop({ default: false }) public autosave?: boolean;

    /**
     * 显示处理提示
     *
     * @type {boolean}
     * @memberof Main4
     */
    @Prop({ default: true }) public showBusyIndicator?: boolean;

    /**
     * 部件行为--submit
     *
     * @type {string}
     * @memberof Main4
     */
    @Prop() public WFSubmitAction!: string;
    
    /**
     * 部件行为--start
     *
     * @type {string}
     * @memberof Main4
     */
    @Prop() public WFStartAction!: string;
    
    /**
     * 部件行为--update
     *
     * @type {string}
     * @memberof Main4
     */
    @Prop() public updateAction!: string;
    
    /**
     * 部件行为--remove
     *
     * @type {string}
     * @memberof Main4
     */
    @Prop() public removeAction!: string;
    
    /**
     * 部件行为--loaddraft
     *
     * @type {string}
     * @memberof Main4
     */
    @Prop() public loaddraftAction!: string;
    
    /**
     * 部件行为--load
     *
     * @type {string}
     * @memberof Main4
     */
    @Prop() public loadAction!: string;
    
    /**
     * 部件行为--create
     *
     * @type {string}
     * @memberof Main4
     */
    @Prop() public createAction!: string;

    /**
     * 部件行为--create
     *
     * @type {string}
     * @memberof Main4
     */
    @Prop() public searchAction!: string;

    /**
     * 视图标识
     *
     * @type {string}
     * @memberof Main4
     */
    @Prop() public viewtag!: string;

    /**
     * 表单状态
     *
     * @type {Subject<any>}
     * @memberof Main4
     */
    public formState: Subject<any> = new Subject();

    /**
     * 忽略表单项值变化
     *
     * @type {boolean}
     * @memberof Main4
     */
    public ignorefieldvaluechange: boolean = false;

    /**
     * 数据变化
     *
     * @public
     * @type {Subject<any>}
     * @memberof Main4
     */
    public dataChang: Subject<any> = new Subject();

    /**
     * 视图状态事件
     *
     * @public
     * @type {(Subscription | undefined)}
     * @memberof Main4
     */
    public dataChangEvent: Subscription | undefined;

    /**
     * 原始数据
     *
     * @public
     * @type {*}
     * @memberof Main4
     */
    public oldData: any = {};

    /**
     * 表单数据对象
     *
     * @type {*}
     * @memberof Main4
     */
    public data: any = {
        srfupdatedate: null,
        srforikey: null,
        srfkey: null,
        srfmajortext: null,
        srftempmode: null,
        srfuf: null,
        srfdeid: null,
        srfsourcekey: null,
        servicename: null,
        empname: null,
        evlregion: null,
        evldate: null,
        evlresult3: null,
        evlresult7: null,
        evlresult2: null,
        evlresult8: null,
        evlresult5: null,
        evlresult6: null,
        evlresult9: null,
        evlresult4: null,
        evlresult1: null,
        evlresult: null,
        serviceevlstate: null,
        evlmark: null,
        orgid: null,
        description: null,
        createman: null,
        createdate: null,
        updateman: null,
        updatedate: null,
        empid: null,
        emserviceevlid: null,
        serviceid: null,
        emserviceevl:null,
    };

    /**
      * 当前执行的行为逻辑
      *
      * @type {string}
      * @memberof Main4
      */
    public currentAction: string = "";

    /**
      * 关系界面计数器
      *
      * @type {number}
      * @memberof Main4
      */
    public drcounter: number = 0;

    /**
      * 需要等待关系界面保存时，第一次调用save参数的备份
      *
      * @type {number}
      * @memberof Main4
      */
    public drsaveopt: any = {};

    /**
      * 表单保存回调存储对象
      *
      * @type {any}
      * @memberof Main4
      */
    public saveState:any ;

    /**
     * 属性值规则
     *
     * @type {*}
     * @memberof Main4
     */
    public rules: any = {
        srfupdatedate: [
            { type: 'string', message: '更新时间 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '更新时间 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '更新时间 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '更新时间 值不能为空', trigger: 'blur' },
        ],
        srforikey: [
            { type: 'string', message: ' 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: ' 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: ' 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: ' 值不能为空', trigger: 'blur' },
        ],
        srfkey: [
            { type: 'string', message: '服务商评估标识 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '服务商评估标识 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '服务商评估标识 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '服务商评估标识 值不能为空', trigger: 'blur' },
        ],
        srfmajortext: [
            { type: 'string', message: '服务商评估名称 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '服务商评估名称 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '服务商评估名称 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '服务商评估名称 值不能为空', trigger: 'blur' },
        ],
        srftempmode: [
            { type: 'string', message: ' 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: ' 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: ' 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: ' 值不能为空', trigger: 'blur' },
        ],
        srfuf: [
            { type: 'string', message: ' 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: ' 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: ' 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: ' 值不能为空', trigger: 'blur' },
        ],
        srfdeid: [
            { type: 'string', message: ' 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: ' 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: ' 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: ' 值不能为空', trigger: 'blur' },
        ],
        srfsourcekey: [
            { type: 'string', message: ' 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: ' 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: ' 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: ' 值不能为空', trigger: 'blur' },
        ],
        servicename: [
            { type: 'string', message: '服务商 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '服务商 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '服务商 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '服务商 值不能为空', trigger: 'blur' },
        ],
        empname: [
            { type: 'string', message: '评估人 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '评估人 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '评估人 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '评估人 值不能为空', trigger: 'blur' },
        ],
        evlregion: [
            { type: 'string', message: '评估区间 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '评估区间 值必须为字符串类型', trigger: 'blur' },
            { required: true, type: 'string', message: '评估区间 值不能为空', trigger: 'change' },
            { required: true, type: 'string', message: '评估区间 值不能为空', trigger: 'blur' },
        ],
        evldate: [
            { type: 'string', message: '评估时间 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '评估时间 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '评估时间 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '评估时间 值不能为空', trigger: 'blur' },
        ],
        evlresult3: [
            { type: 'number', message: '价格(100分,20%) 值必须为数值类型', trigger: 'change' },
            { type: 'number', message: '价格(100分,20%) 值必须为数值类型', trigger: 'blur' },
            { required: false, type: 'number', message: '价格(100分,20%) 值不能为空', trigger: 'change' },
            { required: false, type: 'number', message: '价格(100分,20%) 值不能为空', trigger: 'blur' },
        ],
        evlresult7: [
            { type: 'number', message: '距离(100分,5%) 值必须为数值类型', trigger: 'change' },
            { type: 'number', message: '距离(100分,5%) 值必须为数值类型', trigger: 'blur' },
            { required: false, type: 'number', message: '距离(100分,5%) 值不能为空', trigger: 'change' },
            { required: false, type: 'number', message: '距离(100分,5%) 值不能为空', trigger: 'blur' },
        ],
        evlresult2: [
            { type: 'number', message: '质量(100分,25%) 值必须为数值类型', trigger: 'change' },
            { type: 'number', message: '质量(100分,25%) 值必须为数值类型', trigger: 'blur' },
            { required: false, type: 'number', message: '质量(100分,25%) 值不能为空', trigger: 'change' },
            { required: false, type: 'number', message: '质量(100分,25%) 值不能为空', trigger: 'blur' },
        ],
        evlresult8: [
            { type: 'number', message: '质量管理体系(100分,5%) 值必须为数值类型', trigger: 'change' },
            { type: 'number', message: '质量管理体系(100分,5%) 值必须为数值类型', trigger: 'blur' },
            { required: false, type: 'number', message: '质量管理体系(100分,5%) 值不能为空', trigger: 'change' },
            { required: false, type: 'number', message: '质量管理体系(100分,5%) 值不能为空', trigger: 'blur' },
        ],
        evlresult5: [
            { type: 'number', message: '供货能力(100分,10%) 值必须为数值类型', trigger: 'change' },
            { type: 'number', message: '供货能力(100分,10%) 值必须为数值类型', trigger: 'blur' },
            { required: false, type: 'number', message: '供货能力(100分,10%) 值不能为空', trigger: 'change' },
            { required: false, type: 'number', message: '供货能力(100分,10%) 值不能为空', trigger: 'blur' },
        ],
        evlresult6: [
            { type: 'number', message: '及时性(100分,10%) 值必须为数值类型', trigger: 'change' },
            { type: 'number', message: '及时性(100分,10%) 值必须为数值类型', trigger: 'blur' },
            { required: false, type: 'number', message: '及时性(100分,10%) 值不能为空', trigger: 'change' },
            { required: false, type: 'number', message: '及时性(100分,10%) 值不能为空', trigger: 'blur' },
        ],
        evlresult9: [
            { type: 'number', message: '售后(100分,10%) 值必须为数值类型', trigger: 'change' },
            { type: 'number', message: '售后(100分,10%) 值必须为数值类型', trigger: 'blur' },
            { required: false, type: 'number', message: '售后(100分,10%) 值不能为空', trigger: 'change' },
            { required: false, type: 'number', message: '售后(100分,10%) 值不能为空', trigger: 'blur' },
        ],
        evlresult4: [
            { type: 'number', message: '安全性能(100分,10%) 值必须为数值类型', trigger: 'change' },
            { type: 'number', message: '安全性能(100分,10%) 值必须为数值类型', trigger: 'blur' },
            { required: false, type: 'number', message: '安全性能(100分,10%) 值不能为空', trigger: 'change' },
            { required: false, type: 'number', message: '安全性能(100分,10%) 值不能为空', trigger: 'blur' },
        ],
        evlresult1: [
            { type: 'number', message: '资质(100分,5%) 值必须为数值类型', trigger: 'change' },
            { type: 'number', message: '资质(100分,5%) 值必须为数值类型', trigger: 'blur' },
            { required: false, type: 'number', message: '资质(100分,5%) 值不能为空', trigger: 'change' },
            { required: false, type: 'number', message: '资质(100分,5%) 值不能为空', trigger: 'blur' },
        ],
        evlresult: [
            { type: 'number', message: '总分数 值必须为数值类型', trigger: 'change' },
            { type: 'number', message: '总分数 值必须为数值类型', trigger: 'blur' },
            { required: false, type: 'number', message: '总分数 值不能为空', trigger: 'change' },
            { required: false, type: 'number', message: '总分数 值不能为空', trigger: 'blur' },
        ],
        serviceevlstate: [
            { type: 'string', message: '评估状态 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '评估状态 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '评估状态 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '评估状态 值不能为空', trigger: 'blur' },
        ],
        evlmark: [
            { type: 'string', message: '评价 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '评价 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '评价 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '评价 值不能为空', trigger: 'blur' },
        ],
        orgid: [
            { type: 'string', message: '组织 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '组织 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '组织 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '组织 值不能为空', trigger: 'blur' },
        ],
        description: [
            { type: 'string', message: '描述 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '描述 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '描述 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '描述 值不能为空', trigger: 'blur' },
        ],
        createman: [
            { type: 'string', message: '建立人 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '建立人 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '建立人 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '建立人 值不能为空', trigger: 'blur' },
        ],
        createdate: [
            { type: 'string', message: '建立时间 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '建立时间 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '建立时间 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '建立时间 值不能为空', trigger: 'blur' },
        ],
        updateman: [
            { type: 'string', message: '更新人 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '更新人 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '更新人 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '更新人 值不能为空', trigger: 'blur' },
        ],
        updatedate: [
            { type: 'string', message: '更新时间 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '更新时间 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '更新时间 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '更新时间 值不能为空', trigger: 'blur' },
        ],
        empid: [
            { type: 'string', message: '评估人 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '评估人 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '评估人 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '评估人 值不能为空', trigger: 'blur' },
        ],
        emserviceevlid: [
            { type: 'string', message: '服务商评估标识 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '服务商评估标识 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '服务商评估标识 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '服务商评估标识 值不能为空', trigger: 'blur' },
        ],
        serviceid: [
            { type: 'string', message: '服务商 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '服务商 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '服务商 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '服务商 值不能为空', trigger: 'blur' },
        ],
    }

    /**
     * 详情模型集合
     *
     * @type {*}
     * @memberof Main4
     */
    public detailsModel: any = {
        grouppanel2: new FormGroupPanelModel({ caption: '服务商评估信息', detailType: 'GROUPPANEL', name: 'grouppanel2', visible: true, isShowCaption: false, form: this, uiActionGroup: { caption: '', langbase: 'entities.emserviceevl.main4_form', extractMode: 'ITEM', details: [] } })
, 
        grouppanel19: new FormGroupPanelModel({ caption: '操作信息', detailType: 'GROUPPANEL', name: 'grouppanel19', visible: true, isShowCaption: true, form: this, uiActionGroup: { caption: '', langbase: 'entities.emserviceevl.main4_form', extractMode: 'ITEM', details: [] } })
, 
        formpage1: new FormPageModel({ caption: '基本信息', detailType: 'FORMPAGE', name: 'formpage1', visible: true, isShowCaption: true, form: this })
, 
        srfupdatedate: new FormItemModel({ caption: '更新时间', detailType: 'FORMITEM', name: 'srfupdatedate', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 0 })
, 
        srforikey: new FormItemModel({ caption: '', detailType: 'FORMITEM', name: 'srforikey', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        srfkey: new FormItemModel({ caption: '服务商评估标识', detailType: 'FORMITEM', name: 'srfkey', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 0 })
, 
        srfmajortext: new FormItemModel({ caption: '服务商评估名称', detailType: 'FORMITEM', name: 'srfmajortext', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        srftempmode: new FormItemModel({ caption: '', detailType: 'FORMITEM', name: 'srftempmode', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        srfuf: new FormItemModel({ caption: '', detailType: 'FORMITEM', name: 'srfuf', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        srfdeid: new FormItemModel({ caption: '', detailType: 'FORMITEM', name: 'srfdeid', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        srfsourcekey: new FormItemModel({ caption: '', detailType: 'FORMITEM', name: 'srfsourcekey', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        servicename: new FormItemModel({ caption: '服务商', detailType: 'FORMITEM', name: 'servicename', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        empname: new FormItemModel({ caption: '评估人', detailType: 'FORMITEM', name: 'empname', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        evlregion: new FormItemModel({ caption: '评估区间', detailType: 'FORMITEM', name: 'evlregion', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        evldate: new FormItemModel({ caption: '评估时间', detailType: 'FORMITEM', name: 'evldate', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        evlresult3: new FormItemModel({ caption: '价格(100分,20%)', detailType: 'FORMITEM', name: 'evlresult3', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        evlresult7: new FormItemModel({ caption: '距离(100分,5%)', detailType: 'FORMITEM', name: 'evlresult7', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        evlresult2: new FormItemModel({ caption: '质量(100分,25%)', detailType: 'FORMITEM', name: 'evlresult2', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        evlresult8: new FormItemModel({ caption: '质量管理体系(100分,5%)', detailType: 'FORMITEM', name: 'evlresult8', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        evlresult5: new FormItemModel({ caption: '供货能力(100分,10%)', detailType: 'FORMITEM', name: 'evlresult5', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        evlresult6: new FormItemModel({ caption: '及时性(100分,10%)', detailType: 'FORMITEM', name: 'evlresult6', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        evlresult9: new FormItemModel({ caption: '售后(100分,10%)', detailType: 'FORMITEM', name: 'evlresult9', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        evlresult4: new FormItemModel({ caption: '安全性能(100分,10%)', detailType: 'FORMITEM', name: 'evlresult4', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        evlresult1: new FormItemModel({ caption: '资质(100分,5%)', detailType: 'FORMITEM', name: 'evlresult1', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        evlresult: new FormItemModel({ caption: '总分数', detailType: 'FORMITEM', name: 'evlresult', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        serviceevlstate: new FormItemModel({ caption: '评估状态', detailType: 'FORMITEM', name: 'serviceevlstate', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        evlmark: new FormItemModel({ caption: '评价', detailType: 'FORMITEM', name: 'evlmark', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        orgid: new FormItemModel({ caption: '组织', detailType: 'FORMITEM', name: 'orgid', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        description: new FormItemModel({ caption: '描述', detailType: 'FORMITEM', name: 'description', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        createman: new FormItemModel({ caption: '建立人', detailType: 'FORMITEM', name: 'createman', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 0 })
, 
        createdate: new FormItemModel({ caption: '建立时间', detailType: 'FORMITEM', name: 'createdate', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 0 })
, 
        updateman: new FormItemModel({ caption: '更新人', detailType: 'FORMITEM', name: 'updateman', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 0 })
, 
        updatedate: new FormItemModel({ caption: '更新时间', detailType: 'FORMITEM', name: 'updatedate', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 0 })
, 
        empid: new FormItemModel({ caption: '评估人', detailType: 'FORMITEM', name: 'empid', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        emserviceevlid: new FormItemModel({ caption: '服务商评估标识', detailType: 'FORMITEM', name: 'emserviceevlid', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 0 })
, 
        serviceid: new FormItemModel({ caption: '服务商', detailType: 'FORMITEM', name: 'serviceid', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
    };

    /**
     * 监控表单属性 srfupdatedate 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main4
     */
    @Watch('data.srfupdatedate')
    onSrfupdatedateChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'srfupdatedate', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 srforikey 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main4
     */
    @Watch('data.srforikey')
    onSrforikeyChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'srforikey', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 srfkey 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main4
     */
    @Watch('data.srfkey')
    onSrfkeyChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'srfkey', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 srfmajortext 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main4
     */
    @Watch('data.srfmajortext')
    onSrfmajortextChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'srfmajortext', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 srftempmode 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main4
     */
    @Watch('data.srftempmode')
    onSrftempmodeChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'srftempmode', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 srfuf 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main4
     */
    @Watch('data.srfuf')
    onSrfufChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'srfuf', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 srfdeid 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main4
     */
    @Watch('data.srfdeid')
    onSrfdeidChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'srfdeid', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 srfsourcekey 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main4
     */
    @Watch('data.srfsourcekey')
    onSrfsourcekeyChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'srfsourcekey', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 servicename 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main4
     */
    @Watch('data.servicename')
    onServicenameChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'servicename', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 empname 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main4
     */
    @Watch('data.empname')
    onEmpnameChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'empname', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 evlregion 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main4
     */
    @Watch('data.evlregion')
    onEvlregionChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'evlregion', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 evldate 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main4
     */
    @Watch('data.evldate')
    onEvldateChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'evldate', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 evlresult3 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main4
     */
    @Watch('data.evlresult3')
    onEvlresult3Change(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'evlresult3', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 evlresult7 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main4
     */
    @Watch('data.evlresult7')
    onEvlresult7Change(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'evlresult7', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 evlresult2 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main4
     */
    @Watch('data.evlresult2')
    onEvlresult2Change(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'evlresult2', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 evlresult8 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main4
     */
    @Watch('data.evlresult8')
    onEvlresult8Change(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'evlresult8', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 evlresult5 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main4
     */
    @Watch('data.evlresult5')
    onEvlresult5Change(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'evlresult5', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 evlresult6 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main4
     */
    @Watch('data.evlresult6')
    onEvlresult6Change(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'evlresult6', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 evlresult9 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main4
     */
    @Watch('data.evlresult9')
    onEvlresult9Change(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'evlresult9', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 evlresult4 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main4
     */
    @Watch('data.evlresult4')
    onEvlresult4Change(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'evlresult4', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 evlresult1 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main4
     */
    @Watch('data.evlresult1')
    onEvlresult1Change(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'evlresult1', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 evlresult 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main4
     */
    @Watch('data.evlresult')
    onEvlresultChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'evlresult', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 serviceevlstate 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main4
     */
    @Watch('data.serviceevlstate')
    onServiceevlstateChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'serviceevlstate', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 evlmark 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main4
     */
    @Watch('data.evlmark')
    onEvlmarkChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'evlmark', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 orgid 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main4
     */
    @Watch('data.orgid')
    onOrgidChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'orgid', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 description 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main4
     */
    @Watch('data.description')
    onDescriptionChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'description', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 createman 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main4
     */
    @Watch('data.createman')
    onCreatemanChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'createman', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 createdate 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main4
     */
    @Watch('data.createdate')
    onCreatedateChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'createdate', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 updateman 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main4
     */
    @Watch('data.updateman')
    onUpdatemanChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'updateman', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 updatedate 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main4
     */
    @Watch('data.updatedate')
    onUpdatedateChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'updatedate', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 empid 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main4
     */
    @Watch('data.empid')
    onEmpidChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'empid', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 emserviceevlid 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main4
     */
    @Watch('data.emserviceevlid')
    onEmserviceevlidChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'emserviceevlid', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 serviceid 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main4
     */
    @Watch('data.serviceid')
    onServiceidChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'serviceid', newVal: newVal, oldVal: oldVal });
    }


    /**
     * 重置表单项值
     *
     * @public
     * @param {{ name: string, newVal: any, oldVal: any }} { name, newVal, oldVal }
     * @memberof Main4
     */
    public resetFormData({ name, newVal, oldVal }: { name: string, newVal: any, oldVal: any }): void {
    }

    /**
      * 置空对象
      *
      * @param {any[]} args
      * @memberof EditForm
      */
    public ResetData(_datas:any){
        if(Object.keys(_datas).length >0){
            Object.keys(_datas).forEach((name: string) => {
                if (this.data.hasOwnProperty(name)) {
                    this.data[name] = null;
                }
            });
        }
    }

    /**
     * 表单逻辑
     *
     * @public
     * @param {{ name: string, newVal: any, oldVal: any }} { name, newVal, oldVal }
     * @memberof Main4
     */
    public formLogic({ name, newVal, oldVal }: { name: string, newVal: any, oldVal: any }): void {
                




































    }

    /**
     * 表单值变化
     *
     * @public
     * @param {{ name: string, newVal: any, oldVal: any }} { name, newVal, oldVal }
     * @returns {void}
     * @memberof Main4
     */
    public formDataChange({ name, newVal, oldVal }: { name: string, newVal: any, oldVal: any }): void {
        if (this.ignorefieldvaluechange) {
            return;
        }
        this.resetFormData({ name: name, newVal: newVal, oldVal: oldVal });
        this.formLogic({ name: name, newVal: newVal, oldVal: oldVal });
        this.dataChang.next(JSON.stringify(this.data));
    }

    /**
     * 表单加载完成
     *
     * @public
     * @param {*} [data={}]
     * @param {string} [action]
     * @memberof Main4
     */
    public onFormLoad(data: any = {},action:string): void {
        if(Object.is(action,"save") || Object.is(action,"autoSave") || Object.is(action,"submit"))
        // 更新context的实体主键
        if(data.emserviceevl){
            Object.assign(this.context,{emserviceevl:data.emserviceevl})
        }
        this.setFormEnableCond(data);
        this.fillForm(data,action);
        this.oldData = {};
        Object.assign(this.oldData, JSON.parse(JSON.stringify(this.data)));
        this.$store.commit('viewaction/setViewDataChange', { viewtag: this.viewtag, viewdatachange: false });
        this.formLogic({ name: '', newVal: null, oldVal: null });
    }

    /**
     * 值填充
     *
     * @param {*} [_datas={}]
     * @param {string} [action]
     * @memberof Main4
     */
    public fillForm(_datas: any = {},action:string): void {
        this.ignorefieldvaluechange = true;
        Object.keys(_datas).forEach((name: string) => {
            if (this.data.hasOwnProperty(name)) {
                this.data[name] = _datas[name];
            }
        });
        if(Object.is(action,'loadDraft')){
            this.createDefault();
        }
        if(Object.is(action,'load')){
            this.updateDefault();
        }
        this.$nextTick(function () {
            this.ignorefieldvaluechange = false;
        })
    }

    /**
     * 设置表单项是否启用
     *
     * @public
     * @param {*} data
     * @memberof Main4
     */
    public setFormEnableCond(data: any): void {
        Object.values(this.detailsModel).forEach((detail: any) => {
            if (!Object.is(detail.detailType, 'FORMITEM')) {
                return;
            }
            const formItem: FormItemModel = detail;
            formItem.setEnableCond(data.srfuf);
        });
    }

    /**
     * 重置草稿表单状态
     *
     * @public
     * @memberof Main4
     */
    public resetDraftFormStates(): void {
        const form: any = this.$refs.form;
        if (form) {
            form.resetFields();
        }
    }

    /**
     * 重置校验结果
     *
     * @memberof Main4
     */
    public resetValidates(): void {
        Object.values(this.detailsModel).forEach((detail: any) => {
            if (!Object.is(detail.detailType, 'FORMITEM')) {
                return;
            }
            const formItem: FormItemModel = detail;
            formItem.setError('');
        });
    }

    /**
     * 填充校验结果 （后台）
     *
     * @param {any[]} fieldErrors
     * @memberof Main4
     */
    public fillValidates(fieldErrors: any[]): void {
        fieldErrors.forEach((error: any) => {
            const formItem: FormItemModel = this.detailsModel[error.field];
            if (!formItem) {
                return;
            }
            this.$nextTick(() => {
                formItem.setError(error.message);
            });
        });
    }

    /**
     * 表单校验状态
     *
     * @returns {boolean} 
     * @memberof Main4
     */
    public formValidateStatus(): boolean {
        const form: any = this.$refs.form;
        let validatestate: boolean = true;
        form.validate((valid: boolean) => {
            validatestate = valid ? true : false;
        });
        return validatestate
    }

    /**
     * 获取全部值
     *
     * @returns {*}
     * @memberof Main4
     */
    public getValues(): any {
        return this.data;
    }

    /**
     * 表单项值变更
     *
     * @param {{ name: string, value: any }} $event
     * @returns {void}
     * @memberof Main4
     */
    public onFormItemValueChange($event: { name: string, value: any }): void {
        if (!$event) {
            return;
        }
        if (!$event.name || Object.is($event.name, '') || !this.data.hasOwnProperty($event.name)) {
            return;
        }
        this.data[$event.name] = $event.value;
    }

    /**
     * 设置数据项值
     *
     * @param {string} name
     * @param {*} value
     * @returns {void}
     * @memberof Main4
     */
    public setDataItemValue(name: string, value: any): void {
        if (!name || Object.is(name, '') || !this.data.hasOwnProperty(name)) {
            return;
        }
        if (Object.is(this.data[name], value)) {
            return;
        }
        this.data[name] = value;
    }



    /**
     * 分组界面行为事件
     *
     * @param {*} $event
     * @memberof Main4
     */
    public groupUIActionClick($event: any): void {
        if (!$event) {
            return;
        }
        const item:any = $event.item;
    }

    /**
     * Vue声明周期(处理组件的输入属性)
     *
     * @memberof Main4
     */
    public created(): void {
        this.afterCreated();
    }

    /**
     * 执行created后的逻辑
     *
     *  @memberof Main4
     */    
    public afterCreated(){
        if (this.viewState) {
            this.viewStateEvent = this.viewState.subscribe(({ tag, action, data }) => {
                if (!Object.is(tag, this.name)) {
                    return;
                }
                if (Object.is('autoload', action)) {
                    this.autoLoad(data);
                }
                if (Object.is('load', action)) {
                    this.load(data);
                }
                if (Object.is('loaddraft', action)) {
                    this.loadDraft(data);
                }
                if (Object.is('save', action)) {
                    this.save(data,data.showResultInfo);
                }
                if (Object.is('remove', action)) {
                    this.remove(data);
                }
                if (Object.is('saveandexit', action)) {
                    this.saveAndExit(data);
                }
                if (Object.is('saveandnew', action)) {
                    this.saveAndNew(data);
                }
                if (Object.is('removeandexit', action)) {
                    this.removeAndExit(data);
                }
                if (Object.is('refresh', action)) {
                    this.refresh(data);
                }
            });
        }
        this.dataChang
            .pipe(
                debounceTime(300),
                distinctUntilChanged()
            ).subscribe((data: any) => {
                if (this.autosave) {
                    this.autoSave();
                }
                const state = !Object.is(JSON.stringify(this.oldData), JSON.stringify(this.data)) ? true : false;
                this.$store.commit('viewaction/setViewDataChange', { viewtag: this.viewtag, viewdatachange: state });
            });
    }

    /**
     * vue 生命周期
     *
     * @memberof Main4
     */
    public destroyed() {
        this.afterDestroy();
    }

    /**
     * 执行destroyed后的逻辑
     *
     * @memberof Main4
     */
    public afterDestroy() {
        if (this.viewStateEvent) {
            this.viewStateEvent.unsubscribe();
        }
        if (this.dataChangEvent) {
            this.dataChangEvent.unsubscribe();
        }
    }

    /**
     * 拷贝内容
     *
     * @param {*} [arg={}]
     * @memberof @memberof Main4
     */
    public copy(arg: any = {}): void {
        this.loadDraft(arg);
    }

    /**
     *打印
     *@memberof @memberof Main4
     */
    public print(){
        let _this:any = this;
        _this.$print({id:'form',popTitle:'服务商评估<主编辑>'});
    }

    /**
     * 部件刷新
     *
     * @param {any[]} args
     * @memberof Main4
     */
    public refresh(args: any[]): void {
        let arg: any = {};
        Object.assign(arg,args[0]);
        if (this.data.srfkey && !Object.is(this.data.srfkey, '')) {
            Object.assign(arg, { srfkey: this.data.srfkey });
            this.load(arg);
            return;
        }
        if (this.data.srfkeys && !Object.is(this.data.srfkeys, '')) {
            Object.assign(arg, { srfkey: this.data.srfkeys });
            this.load(arg);
            return;
        }
    }

    /**
     * 自动加载
     *
     * @param {*} [arg={}]
     * @returns {void}
     * @memberof Main4
     */
    public autoLoad(arg: any = {}): void {
        if (arg.srfkey && !Object.is(arg.srfkey, '')) {
            Object.assign(arg, { srfkey: arg.srfkey });
            this.load(arg);
            return;
        }
        if (arg.srfkeys && !Object.is(arg.srfkeys, '')) {
            Object.assign(arg, { srfkey: arg.srfkeys });
            this.load(arg);
            return;
        }
        this.loadDraft(arg);
    }

    /**
     * 加载
     *
     * @public
     * @param {*} [opt={}]
     * @memberof Main4
     */
    public load(opt: any = {}): void {
        if(!this.loadAction){
            this.$Notice.error({ title: '错误', desc: 'EMSERVICEEVLEditView9_EditMode视图表单loadAction参数未配置' });
            return;
        }
        const arg: any = { ...opt };
        let viewparamResult:any = Object.assign(arg,this.viewparams);
        const get: Promise<any> = this.service.get(this.loadAction,JSON.parse(JSON.stringify(this.context)),{viewparams:viewparamResult}, this.showBusyIndicator);
        get.then((response: any) => {
            if (response && response.status === 200) {
                const data = response.data;
                this.onFormLoad(data,'load');
                this.$emit('load', data);
                this.$nextTick(() => {
                    this.formState.next({ type: 'load', data: data });
                });
            }
        }).catch((response: any) => {
            if (response && response.status && response.data) {
                this.$Notice.error({ title: '错误', desc: response.data.message });
                return;
            }
            if (!response || !response.status || !response.data) {
                this.$Notice.error({ title: '错误', desc: '系统异常' });
                return;
            }
        });
    }

    /**
     * 加载草稿
     *
     * @param {*} [opt={}]
     * @memberof Main4
     */
    public loadDraft(opt: any = {}): void {
        if(!this.loaddraftAction){
            this.$Notice.error({ title: '错误', desc: 'EMSERVICEEVLEditView9_EditMode视图表单loaddraftAction参数未配置' });
            return;
        }
        const arg: any = { ...opt } ;
        let viewparamResult:any = Object.assign(arg,this.viewparams);
        let post: Promise<any> = this.service.loadDraft(this.loaddraftAction,JSON.parse(JSON.stringify(this.context)),{viewparams:viewparamResult}, this.showBusyIndicator);
        post.then((response: any) => {
            if (!response.status || response.status !== 200) {
                if (response.data) {
                    this.$Notice.error({ title: '错误', desc: response.data.message });
                }
                return;
            }

            const data = response.data;
            if(data.emserviceevl){
                Object.assign(this.context,{emserviceevl:data.emserviceevl})
            }
            this.resetDraftFormStates();
            this.onFormLoad(data,'loadDraft');
            this.$emit('load', data);
            this.$nextTick(() => {
                this.formState.next({ type: 'load', data: data });
            });
            setTimeout(() => {
                const form: any = this.$refs.form;
                if (form) {
                    form.fields.forEach((field: any) => {
                        field.validateMessage = "";
                        field.validateState = "";
                        field.validateStatus = false;
                    });
                }
            });
        }).catch((response: any) => {
            if (response && response.status  && response.data) {
                this.$Notice.error({ title: '错误', desc: response.data.message });
                return;
            }
            if (!response || !response.status || !response.data) {
                this.$Notice.error({ title: '错误', desc: '系统异常' });
                return;
            }
        });
    }

    /**
     * 自动保存
     *
     * @param {*} [opt={}]
     * @memberof Main4
     */
    public autoSave(opt: any = {}): void {
        if (!this.formValidateStatus()) {
            return;
        }
        const arg: any = { ...opt };
        const data = this.getValues();
        Object.assign(arg, data);
        const action: any = Object.is(data.srfuf, '1') ? this.updateAction : this.createAction;
        if(!action){
            let actionName:any = Object.is(data.srfuf, '1')?"updateAction":"createAction";
            this.$Notice.error({ title: '错误', desc: 'EMSERVICEEVLEditView9_EditMode视图表单'+actionName+'参数未配置' });
            return;
        }
        Object.assign(arg,{viewparams:this.viewparams});
        const post: Promise<any> = this.service.add(action, JSON.parse(JSON.stringify(this.context)),arg, this.showBusyIndicator);
        post.then((response: any) => {
            if (!response.status || response.status !== 200) {
                if (response.data) {
                    this.$Notice.error({ title: '错误', desc: response.data.message });
                }
                return;
            }

            const data = response.data;
            this.onFormLoad(data,'autoSave');
            this.$emit('save', data);
            this.$store.dispatch('viewaction/datasaved', { viewtag: this.viewtag });
            this.$nextTick(() => {
                this.formState.next({ type: 'save', data: data });
            });
        }).catch((response: any) => {
            if (response && response.status && response.data) {
                this.$Notice.error({ title: '错误', desc: response.data.message });
                return;
            }
            if (!response || !response.status || !response.data) {
                this.$Notice.error({ title: '错误', desc: '系统异常' });
                return;
            }
        });
    }

    /**
     * 保存
     *
     * @param {*} [opt={}]
     * @param {boolean} [showResultInfo] 
     * @param {boolean} [ifStateNext] formState是否下发通知
     * @returns {Promise<any>}
     * @memberof Main4
     */
    public async save(opt: any = {}, showResultInfo?: boolean, ifStateNext: boolean = true): Promise<any> {
        return new Promise((resolve: any, reject: any) => {
            showResultInfo = showResultInfo === undefined ? true : false;
            if (!this.formValidateStatus()) {
                this.$Notice.error({ title: '错误', desc: '值规则校验异常' });
                return;
            }
            const arg: any = { ...opt };
            const data = this.getValues();
            Object.assign(arg, data);
            Object.assign(arg, this.context);
            if (ifStateNext) {
                this.drcounter = 0;
                if(this.drcounter !== 0){
                    this.drsaveopt = opt;
                    this.formState.next({ type: 'beforesave', data: arg });//先通知关系界面保存
                    this.saveState = resolve;
                    return;
                }
            }
            const action: any = Object.is(data.srfuf, '1') ? this.updateAction : this.createAction;
            if(!action){
                let actionName:any = Object.is(data.srfuf, '1')?"updateAction":"createAction";
                this.$Notice.error({ title: '错误', desc: 'EMSERVICEEVLEditView9_EditMode视图表单'+actionName+'参数未配置' });
                return;
            }
            Object.assign(arg,{viewparams:this.viewparams});
            const post: Promise<any> = Object.is(data.srfuf, '1')?this.service.update(action, JSON.parse(JSON.stringify(this.context)),arg, this.showBusyIndicator):this.service.add(action,JSON.parse(JSON.stringify(this.context)),arg, this.showBusyIndicator);
            post.then((response: any) => {
                if (!response.status || response.status !== 200) {
                    if (response.data) {
                        this.$Notice.error({ title: '错误', desc: response.data.message });
                    }
                    return;
                }

                const data = response.data;
                this.onFormLoad(data,'save');
                this.$emit('save', data);
                this.$store.dispatch('viewaction/datasaved', { viewtag: this.viewtag });
                this.$nextTick(() => {
                    this.formState.next({ type: 'save', data: data });
                });
                if (showResultInfo) {
                    this.$Notice.success({ title: '', desc: (data.srfmajortext ? data.srfmajortext : '') + '&nbsp;保存成功！' });
                }
                resolve(response);
            }).catch((response: any) => {
                if (response && response.status  && response.data) {
                    this.$Notice.error({ title: '错误', desc: response.data.message });
                    reject(response);
                    return;
                }
                if (!response || !response.status || !response.data) {
                    this.$Notice.error({ title: '错误', desc: '系统异常' });
                    reject(response);
                    return;
                }
                reject(response);
            });
        })
    }

    /**
    * 删除
    *
    * @public
    * @param {*} [opt={}]
    * @memberof EditForm
    */
    public remove(opt:Array<any> = [],showResultInfo?: boolean): Promise<any> {
        return new Promise((resolve: any, reject: any) => {
            if(!this.removeAction){
                this.$Notice.error({ title: '错误', desc: 'EMSERVICEEVLEditView9_EditMode视图表单removeAction参数未配置' });
                return;
            }
            const arg: any = opt[0];
            const _this: any = this;
            Object.assign(arg,{viewparams:this.viewparams});
            this.service.delete(_this.removeAction, JSON.parse(JSON.stringify(this.context)),arg, showResultInfo).then((response: any) => {
                if (response) {
                    const data = response.data;
                    this.$emit('remove',data);
                    this.formState.next({ type: 'remove', data: data });
                    this.data.ismodify = false;
                    this.$Notice.success({ title: '', desc: (data.srfmajortext ? data.srfmajortext : '') + '&nbsp;删除成功！' });
                    resolve(response);
                }
            }).catch((error: any) => {
                const { data: _data } = error;
                this.$Notice.error({ title: _data.title, desc: _data.message });
                reject(error);
            });
        });
    }

    /**
     * 工作流启动
     *
     * @param {*} [data={}]
     * @param {*} [localdata={}]
     * @returns {Promise<any>}
     * @memberof Main4
     */
    public async wfstart(data: any,localdata?:any): Promise<any> {
        return new Promise((resolve: any, reject: any) => {
            const _this: any = this;
            const post: Promise<any> = _this.save({},false);
            post.then((response:any) =>{
                const arg:any = response.data;
                if(this.viewparams){
                    Object.assign(arg,{viewparams:this.viewparams});
                }
                const result: Promise<any> = this.service.wfstart(_this.WFStartAction, JSON.parse(JSON.stringify(this.context)),arg, this.showBusyIndicator,localdata);
                result.then((response: any) => {
                    if (!response || response.status !== 200) {
                        if(response.data){
                            this.$Notice.error({ title: '', desc: '工作流启动失败, ' + response.data.message });
                        }
                        return;
                    }
                    this.$Notice.info({ title: '', desc: '工作流启动成功' });
                    resolve(response);
            }).catch((response: any) => {
                if (response && response.status && response.data) {
                    this.$Notice.error({ title: '错误', desc: response.data.message });
                    reject(response);
                    return;
                }
                if (!response || !response.status || !response.data) {
                    this.$Notice.error({ title: '错误', desc: '系统异常' });
                    reject(response);
                    return;
                }
                reject(response);
            });
            }).catch((response: any) => {
                    if (response && response.status && response.data) {
                        this.$Notice.error({ title: '错误', desc: response.data.message });
                        reject(response);
                        return;
                    }
                    if (!response || !response.status || !response.data) {
                        this.$Notice.error({ title: '错误', desc: '系统异常' });
                        reject(response);
                        return;
                    }
                    reject(response);
            })
        });
    }

    /**
     * 工作流提交
     *
     * @param {*} [data={}]
     * @param {*} [localdata={}]
     * @returns {Promise<any>}
     * @memberof Main4
     */
    public async wfsubmit(data: any,localdata?:any): Promise<any> {
        return new Promise((resolve: any, reject: any) => {
        const _this: any = this;
        const arg: any = data[0];
        Object.assign(arg,{viewparams:this.viewparams});
        if (!arg.emserviceevl || Object.is(arg.emserviceevl, '')) {
            return;
        }
        const post: Promise<any> = Object.is(arg.srfuf, '1')?this.service.update(this.updateAction, JSON.parse(JSON.stringify(this.context)),arg, this.showBusyIndicator):this.service.add(this.createAction,JSON.parse(JSON.stringify(this.context)),arg, this.showBusyIndicator);
        post.then((response:any) =>{
                const arg:any = response.data;
                // 保存完成UI处理
                this.onFormLoad(arg,'save');
                this.$emit('save', arg);
                this.$nextTick(() => {
                    this.formState.next({ type: 'save', data: arg });
                });
                // 准备提交参数
                if(this.viewparams){
                    Object.assign(arg,{viewparams:this.viewparams});
                }
                const result: Promise<any> = this.service.wfsubmit(_this.WFSubmitAction, JSON.parse(JSON.stringify(this.context)),arg, this.showBusyIndicator,localdata);
                result.then((response: any) => {
                    if (!response || response.status !== 200) {
                        if(response.data){
                            this.$Notice.error({ title: '', desc: '工作流提交失败, ' + response.data.message });
                        }
                        return;
                    }
                    this.onFormLoad(arg,'submit');
                    this.$store.dispatch('viewaction/datasaved', { viewtag: this.viewtag });
                    this.$Notice.info({ title: '', desc: '工作流提交成功' });
                    resolve(response);
            }).catch((response: any) => {
                if (response && response.status && response.data) {
                    this.$Notice.error({ title: '错误', desc: response.data.message });
                    reject(response);
                    return;
                }
                if (!response || !response.status || !response.data) {
                    this.$Notice.error({ title: '错误', desc: '系统异常' });
                    reject(response);
                    return;
                }
                reject(response);
            });
            }).catch((response: any) => {
                    if (response && response.status && response.data) {
                        this.$Notice.error({ title: '错误', desc: response.data.message });
                        reject(response);
                        return;
                    }
                    if (!response || !response.status || !response.data) {
                        this.$Notice.error({ title: '错误', desc: '系统异常' });
                        reject(response);
                        return;
                    }
                    reject(response);
            })
        })
    }

    /**
     * 表单项更新
     *
     * @param {string} mode 界面行为名称
     * @param {*} [data={}] 请求数据
     * @param {string[]} updateDetails 更新项
     * @param {boolean} [showloading] 是否显示加载状态
     * @returns {void}
     * @memberof Main4
     */
    public updateFormItems(mode: string, data: any = {}, updateDetails: string[], showloading?: boolean): void {
        if (!mode || (mode && Object.is(mode, ''))) {
            return;
        }
        const arg: any = { ...data };
        Object.assign(arg,this.viewparams);
        const post: Promise<any> = this.service.frontLogic(mode,JSON.parse(JSON.stringify(this.context)),arg, showloading);
        post.then((response: any) => {
            if (!response || response.status !== 200) {
                this.$Notice.error({ title: '错误', desc: '表单项更新失败' });
                return;
            }
            const data = response.data;
            const _data: any = {};
            updateDetails.forEach((name: string) => {
                if (!data.hasOwnProperty(name)) {
                    return;
                }
                Object.assign(_data, { [name]: data[name] });
            });
            this.setFormEnableCond(_data);
            this.fillForm(_data,'updateFormItem');
            this.formLogic({ name: '', newVal: null, oldVal: null });
            this.dataChang.next(JSON.stringify(this.data));
            this.$nextTick(() => {
                this.formState.next({ type: 'updateformitem', ufimode: arg.srfufimode, data: _data });
            });
        }).catch((response: any) => {
            if (response && response.status && response.data) {
                this.$Notice.error({ title: '错误', desc: response.data.message });
                return;
            }
            if (!response || !response.status || !response.data) {
                this.$Notice.error({ title: '错误', desc: '系统异常' });
                return;
            }
        });
    }

    /**
     * 回车事件
     *
     * @param {*} $event
     * @memberof Main4
     */
    public onEnter($event: any): void {
    }

    /**
     * 保存并退出
     *
     * @param {any[]} args
     * @memberof Main4
     */
    public saveAndExit(data:any[]):Promise<any>{
        let _this = this;
        return new Promise((resolve: any, reject: any) =>{
            let arg: any = {};
            if(data && data.length > 0){
                Object.assign(arg,data[0]);
            }
            _this.currentAction = "saveAndExit";
            _this.save([arg]).then((res) =>{
                if(res){
                    _this.closeView(res.data);
                }
                resolve(res);
            }).catch((error) =>{
                reject(error);
            })
        })
    }

    /**
     * 保存并新建
     *
     * @param {any[]} args
     * @memberof Main4
     */
    public saveAndNew(data:any[]):Promise<any>{
        let _this = this;
        return new Promise((resolve: any, reject: any) =>{
            let arg: any = {};
            if(data && data.length > 0){
                Object.assign(arg,data[0]);
            }
            _this.currentAction = "saveAndNew";
            _this.save([arg]).then((res) =>{
                _this.ResetData(res);
                _this.loadDraft({});
            }).catch((error) =>{
                reject(error);
            })
        })
    }

    /**
     * 删除并退出
     *
     * @param {any[]} args
     * @memberof Main4
     */
    public removeAndExit(data:any[]):Promise<any>{
        let _this = this;
        return new Promise((resolve: any, reject: any) =>{
            let arg: any = {};
            if(data && data.length > 0){
                Object.assign(arg,data[0]);
            }
            _this.remove([arg]).then((res) =>{
                if(res){
                  _this.closeView(res.data);
                }
                resolve(res);
            }).catch((error) =>{
                reject(error);
            })
        })
    }

    /**
    * 关系界面数据保存完成
    *
    * @param {any} $event
    * @memberof Main4
    */
    public drdatasaved($event:any){
        let _this = this;
        this.drcounter--;
        if(this.drcounter > 0){
            return;
        }
        this.save(this.drsaveopt, undefined, false).then((res) =>{
            this.saveState(res);
            this.drsaveopt = {};
            if(Object.is(_this.currentAction, "saveAndNew")){
                _this.ResetData(res);
                _this.loadDraft({});
            }else if(Object.is(_this.currentAction, "saveAndExit")){
                if(res){
                    _this.closeView(res.data);
                }
            }
        });
    }

    /**
     * 新建默认值
     * @memberof Main4
     */
    public createDefault(){                    
    }

    /**
     * 更新默认值
     * @memberof Main4
     */
    public updateDefault(){                    
    }

    
}
</script>

<style lang='less'>
@import './main4-form.less';
</style>